package no.omim.engine;

import java.io.BufferedWriter;
import java.io.FileWriter;

import org.apache.log4j.Logger;

public class IndexStarter {
	
	private String _indexDirectory = "C:/indexDirectory";
	private static Logger logger = Logger.getLogger("applogger");
	
	public IndexStarter() throws Exception {
		Garcia index;
		Searcher search;
		QueryResultList queryList;
		QueryResult queryRes;
		BufferedWriter bufW;
		
		/*
		//logger.debug("Start indexing");
		index = new Garcia(this._indexDirectory + "/luceneIndex");
		//logger.debug("Read OMIM collection");
		
		index.setUp(this._indexDirectory + "/OMIMCollection");
		//logger.debug("Transfer index to SVD matrix");
		index.transferToSVDMatrix();
		
		//logger.debug("Perform SVD");
		index.performSVD();
		//logger.debug("Perform k-means");
		//index.performKMeans();
		*/
		// Perform k-means
		KMeans kMeans;
		int numClusters = 3; // SKAL BRUKE 5 VED ENDELIG VERSJON
		
		String dirPath = this._indexDirectory + "/luceneIndex";
		
		logger.debug("Inni performKMeans");
		kMeans = new KMeans(numClusters, dirPath);
		logger.debug("createClusters");
		kMeans.createClusters();
		logger.debug("populateClusters");
		kMeans.populateClusters();
		
		logger.debug("writeKMeansClusterToFile");
		kMeans.writeKMeansClustersToFile(kMeans.get(), numClusters, dirPath);
		
		
		// TEST
		TwoStepKMeans min;
		min = new TwoStepKMeans(numClusters, dirPath);
		min.createClusters();
		min.populateClusters();
		min.writeKMeansClustersToFile(min.get(), numClusters, dirPath + "/TwoStepKMeans");
		// TEST END
		
		
		//logger.debug("IndexStarter: END!");
		
		
		//logger.debug("Start searching");
		search = new Searcher(dirPath); // opprinnelig this._indexDirectory
		//logger.debug("Search");
		queryList = search.search("character zymogen", false);
		// SORTER RESULTATLISTEN
		
		//logger.debug("Resultatliste inneholder " + queryList.getNumberOfRetrievedDocs() + " dokument(er)");
		
		queryList.sortResult();
		
		// DEBUG
		int numDocs = queryList.getNumberOfRetrievedDocs();
		
		for (int i = 0; i < numDocs; i++) {
			logger.debug("Dokument " + i + " i resultatlisten med " +
					queryList.getResult(i).getSimToQuery() + " i likhet");
		}
	}
}
