package no.omim.engine;

public class TwoStepKMeans extends KMeans {
	// TODO legg min versjon av k-means funksjoner her
	
	public TwoStepKMeans(int numClusters, String dirPath) throws Exception {
		super(numClusters, dirPath);
	}
	
	
	public void populateClusters() {
		// Innkapsle kallene med en lkke som gjr at den kjres helt til centroidene ikke flytter p seg
		// jfr. populate-funksjonen
		// Legg til enda en parameter for  styre den globale plasseringen av dokumenter eller gjr om den boolske
		// til  vre et tall? Eks.:
		//for (int i = 0; i < 3; i++) {
		//	populate(i);
		//}
		// logger.debug("TwoStepKMeans AVSLUTTET!");
		
		populate(true);
		populate(false);
	}
	
	
	public void populate(boolean local) {
		/*
		 * TODO:
		 * - overstyr populateCluster-metoden slik at den fungerer slik som beskrevet i
		 *   "Forslag til alternativ versjon av k-means", evt. slik som nedenfor
		 * 
		 * - overstyr plasseringen av klyngedata
		 * 
		 * SNU OM SLIK AT DEN LEGGER TIL DE DOKUMENTENE SOM ER LENGST UNNA FRST, FOR S 
		 * SNEVRE INN?
		 * 
		 * TODO alternativt:
		 * For hver runde, finn lokal centroide, finn global centroide, sammenlign den forrige globale
		 * centroiden med den nye globale centroiden... gjr dette til centroiden ikke flytter p seg.
		 * Det vil si at jeg m innkapsle det jeg har gjort her n med en rekursiv funksjon som gr
		 * helt til de gamle og de nye centroidene er like. Dette kan jo bli spennende.
		 * 
		 * ELLER (denne skal jeg forske  f gjort 3. april!):
		 * Hvis et dokument har en likhet over 0.9 med flere klynger enn 1, s blir den ikke tatt med
		 * nr den nye lokale centroiden skal finnes... dette vil vel tvinge centroiden til  flytte mer
		 * p seg og en vil vel da kanskje ha en sjanse til  f en litt mindre grdig k-means. Ulempen
		 * vil vre at en kan f en uendelig loop.
		 * 
		 * Sjekk flgende:
		 * - Hva om den lokale centroiden flyttes helt til den ikke flytter seg noe mer fr den
		 *   globale centroiden flyttes? Da vil den vel kunne oppn en "lokal" centroideplassering
		 *   fr den plasserer seg globalt. Kan det vre en mte  gjre det p den mten? Alts
		 *   for hver runde finner den en "optimal" plassering for den lokale centroiden fr den
		 *   gjr det for den globale, nr den globale ikke har flyttet seg siden den forrige
		 *   runden, s avsluttes metoden og klyngene skrives til fil.
		 */
		
		//logger.debug("TwoStepKMeans sin populateClusters");
		//logger.debug("");
		
		boolean repeatPopulation = false;
		Cluster objCluster;
		
		for (int row = 0; row < this._numDocs; row++) {
			double[] arrSim;
			double[] arrDocVec;
			
			arrSim = new double[this._numClusters];
			arrDocVec = new double[this._k];
			
			arrDocVec = createDocVector(this._k, row);
			
			arrSim = computeDocClusterSim(arrDocVec);
			
			int cluster;
			
			if ((cluster = closestCluster(arrSim, local)) != -1) {
				objCluster = this._arrClusters.getCluster(cluster); //closestCluster(arrSim, local));
				objCluster.setClusterDocuments(this._documents.get(row), row); // TODO sjekk
				//logger.debug("Mest lik klynge: " + objCluster.getClusterID() + "/" + cluster + "; likhet: " + arrSim[closestCluster(arrSim)]);
				//logger.debug("");
			}
		}
		
		repeatPopulation = recomputeCentroid();
		
		// hvis sann, repopuler klyngene
		if (repeatPopulation) {
			
			for (int i = 0; i < this._numClusters; i++) {
				objCluster = this._arrClusters.getCluster(i);
				objCluster.clearClusterDocuments();
			}
			
			populate(local);
		}
		
		if (local) {
			for (int j = 0; j < this._numClusters; j++) {
				objCluster = this._arrClusters.getCluster(j);
				objCluster.clearClusterDocuments();
			}
		}
		//logger.debug("LOCAL POPULATE CLUSTERS END! local: " + Boolean.toString(local));
		//logger.debug("");
	}
	
	
	public int closestCluster(double[] arrSim, boolean local) {
		int clusterNumber = -1; // 0
		int size = arrSim.length;
		int numberOf = 0;
		double maxSimValue = -1; // arrSim[0]
		
		for (int i = 0; i < size; i++) { // 1
			double arrSimValue = arrSim[i];
			
			if (local) { // hvis lage ny lokal centroide, sjekk
				if ((arrSimValue > maxSimValue) && (arrSimValue > 0.85)) { // strre enn max og 0.9 (m sjekke om verdien er fornuftig)
																		   // m trolig forandre p denne verdien nr flere dokumenter
																		   // blir brukt (en verdi p rundt 0.4-0.5 regner jeg med
																		   // det blir)
					//logger.debug("arrSimValue > maxSimValue && arrSimValue > 0.85; " + "klynge " + i);
					maxSimValue = arrSimValue;
					clusterNumber = i;
					numberOf++;
				}
			} else { // hvis lage ny global centroide, sjekk
				if (arrSimValue > maxSimValue) { // strre enn max
					maxSimValue = arrSimValue;
					clusterNumber = i;
				}
			}
		}
		
		// hvis numberOf er strre enn 1, returner -1
		if (numberOf > 1) { // numberOf er 0 uansett hvis det er den globale centroiden som skal finnes
			//logger.debug("returnerer -1");
			//logger.debug("");
			return -1;
		} else { // ellers returner klyngenummer for klyngen som er mest lik dokumentet
			//logger.debug("returnerer " + clusterNumber);
			//logger.debug("");
			return clusterNumber; // opprinnelig kun return clusterNumber;
		}
	}
}