package no.omim.engine.analyzer.filter;

import java.io.IOException;
import java.util.Set;

import org.apache.lucene.analysis.Token;
import org.apache.lucene.analysis.TokenFilter;
import org.apache.lucene.analysis.TokenStream;


import org.apache.log4j.Logger;

public class OMIMStopfilter extends TokenFilter {
	
	private static Logger logger = Logger.getLogger("applogger");
	private Set stopWords;
	
	public OMIMStopfilter(TokenStream in, Set stopWords) {
		super(in);
		this.stopWords = stopWords;
		/**
	     * Inndelingen av felter som skal analyseres p forskjellige mter, m ordnes her
	     * eller i next-funksjonen. *RECORD* og dens typebeskrivelse (TI, TX, etc.) skal
	     * ikke indekseres.
	     */
	}
	
	public final Token next() throws IOException {
		int increment = 0;
		for (Token token = input.next(); token != null; token = input.next()) {
			if (!stopWords.contains(token.termText())) {
				token.setPositionIncrement(token.getPositionIncrement() + increment);
				return token;
			}
			
			increment++;
		}
		
		return null;
	}
}
