package no.omim.servlet;

import java.util.HashMap;
import javax.servlet.*;

import org.apache.log4j.Logger;

public class ActionHelper {
	
	private static HashMap<String, String> actions = new HashMap<String, String>();
	private static Logger logger = Logger.getLogger("applogger");
	
	static {
		actions.put("", "no.omim.servlet.InitialViewAction");
		actions.put("Search", "no.omim.servlet.SearchAction");
		actions.put("OMIMCollection", "no.omim.servlet.CollectionAction");
	}
	
	public static Action getAction(String name) throws ServletException {
		Action action = null;
		
		try
		{
			logger.debug("find a class for the action");
			logger.debug("name: " + (String)actions.get(name));
			Class c = Class.forName((String)actions.get(name));
			action = (Action)c.newInstance();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
		
		return action;
	}
}
