package no.omim.servlet;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;

public class Download {
	static Logger logger = Logger.getLogger("applogger");	
	
	public void downloadFile(HttpServletRequest req, HttpServletResponse res, String filename) throws IOException {
		logger.debug("processing downloadAction");
		logger.debug("Filename: " + filename);
		res.setContentType("application/x-download");
		res.setHeader("content-Disposition", "attachment; filename=" + filename);
		
		OutputStream out = res.getOutputStream();
		returnFile(filename, out);
	}
	
	public void returnFile(String filename, OutputStream out) throws FileNotFoundException, IOException {
		InputStream in = null;
		try {
			in = new BufferedInputStream(new FileInputStream(filename));
			byte[] buf = new byte [4 * 1024];
			int bytesRead;
			while ((bytesRead = in.read(buf)) != -1) {
				out.write(buf, 0, bytesRead);
			}
		}
		finally {
			if (in != null) in.close();
		}
	}
}
