package no.omim.servlet;

import java.io.IOException;
import java.io.InputStream;

import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.log4j.*;

public class OmimsearchServlet extends HttpServlet {
	
	static final long serialVersionUID = 12827474;
	static Logger logger = Logger.getLogger("applogger");
	private String lucene = "";
	
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		ServletContext context = getServletContext();
		lucene = (String)context.getInitParameter("luceneIndexDir");
	}
	
	protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {		
		processRequest(req, res);		
	}
	
	protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {		
		processRequest(req, res);		
	}
	
	protected void processRequest(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		logger.debug("processing request");		
		Action action = ActionHelper.getAction(req.getPathInfo().substring(1));
		
		if (!(action instanceof no.omim.servlet.CollectionAction)) {
			String nextView = action.process(req, res, this.lucene);
			
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(nextView);
			dispatcher.forward(req, res);
		} else {
			logger.debug("CollectionAction");
			String filename = "";
			Download download = new Download();
			filename = req.getParameter("docID");
			logger.debug("Filename: " + filename);
			download.downloadFile(req, res, this.lucene + "OMIMCollection/" + filename);
		}		
	}
}
 