package no.omim.servlet;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import no.omim.engine.QueryResult;
import no.omim.engine.QueryResultList;
import no.omim.engine.Searcher;

import org.apache.log4j.Logger;

import java.util.ArrayList;
//import java.util.Vector;

public class SearchAction extends Action {
	
	static Logger logger = Logger.getLogger("applogger");	

	public String process(HttpServletRequest request, HttpServletResponse response, String luceneIndex) {
		HttpSession session = null;
		//Vector<QueryResult> vctResult;
		QueryResultList list = null;		
		
		try {
			logger.debug("processing SearchAction");
			session = request.getSession();

			// perform the search and retrieve any results						
			list = performSearch(request, response, luceneIndex);
						
			// put the collection of result-object into the session
			session.setAttribute("SEARCH_RESULT_COLLECTION_LIST", list);
			logger.debug("arrResult added to the session");
		}
		catch (Exception ex) {
			logger.error("error: " + ex.getMessage());			
		}
		finally {
			session = null;
			list = null;
		}
		return "/searchform.jsp";
	}

	private QueryResultList performSearch(HttpServletRequest request, HttpServletResponse response, String luceneIndex) {
		QueryResultList list = new QueryResultList();
		HttpSession session = null;
		Searcher objSearcher;
		String strTerm = "";
		String strAlgorithm = "";
		boolean blnTwoStep = false;
		
		try {
			session = request.getSession();
			
//			 get the search-parameters from the request
			if (request.getParameter("txtTerm") != null) {
				strTerm = request.getParameter("txtTerm");
			}
			logger.debug("strTerm: " + strTerm);
			
			if (request.getParameter("algorithm") != null) {
				strAlgorithm = request.getParameter("algorithm");
			}
			logger.debug("strAlgorithm: " + strAlgorithm);
			
			if (strAlgorithm.equals("twostep")) {
				blnTwoStep = true;
			}
			
			// put the search parameters into the session			
			session.setAttribute("SEARCH_TERM", strTerm);
			session.setAttribute("SEARCH_ALGORITHM", strAlgorithm);			
			
			objSearcher = new Searcher(luceneIndex);
			if (!strTerm.equals(""))
			{
				list = objSearcher.search(strTerm, blnTwoStep);
				//logger.debug("objSearcher: " + objSearcher.search(strTerm, blnTwoStep).getResultCol().get(0).getDocPath());
			}
			
			//logger.debug("vctResult: " + vctResult.size());
			return list;
		}
		catch(Exception ex) {
			logger.error("error: " + ex.getMessage());
			return new QueryResultList();
		}
		finally {
			list = null;
			objSearcher = null;
			session = null;
		}		
	}
}
